Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices

Module user_supplied_function
    ' Copyright Numerical Algorithms Group 2012

    ' The user-supplied function objfun.

    ' Note that array arguments cannot be passed directly from
    ' the NAG C Library DLL to Visual Basic in a way in which
    ' they can be accessed. Instead, we need to pass pointers
    ' to the arrays, then use the Marshal.Copy function to
    ' get hold of the actual contents.

    ' Skeleton for call-back function objfun_user of type e04dgc_objfun_DELEGATE
    ' Sub objfun_user( _
    '    ByVal n As Integer, _
    '    ByVal x_rptr As IntPtr, _
    '    ByRef objf As Double, _
    '    ByVal g_rptr As IntPtr, _
    '    ByRef comm As Nag_Comm _
    '  )
    ' Insert code here.
    ' End Sub

    Sub objfun(ByVal n As Integer, ByVal x_ptr As IntPtr, ByRef objf As Double, ByVal g_ptr As IntPtr, ByRef comm_ptr As Nag_Comm)
        Dim x(n - 1) As Double
        Dim g(n - 1) As Double

        ' Copy from the input array pointer x_ptr to our local array x.
        Call Marshal.Copy(x_ptr, x, 0, n)

        objf = Math.Exp(x(0)) * (x(0) * 4.0# * (x(0) + x(1)) + x(1) * 2.0# * (x(1) + 1.0#) + 1.0#)

        g(0) = 4.0# * Math.Exp(x(0)) * (2.0# * x(0) + x(1)) + objf
        g(1) = 2.0# * Math.Exp(x(0)) * (2.0# * x(1) + 2.0# * x(0) + 1.0#)

        ' Copy the array g back to the NAG C Library calling function.
        Call Marshal.Copy(g, 0, g_ptr, n)
    End Sub
End Module